function E = edges8connected(height,width)

% EDGE8CONNECTED Creates edges where each node
%   is connected to its four adjacent neighbors on a 
%   height x width grid.
%   E - a vector in which each row i represents an edge
%   E(i,1) --> E(i,2). The edges are listed is in the following 
%   neighbor order: down,up,right,left, where nodes 
%   indices are taken column-major.
%
%   based on edges4connected of (c) 2008 Michael Rubinstein, WDI R&D and IDC
%

N = height*width;
I = []; J = [];
% connect vertically (down, then up)
is = [1:N]'; is([height:height:N])=[];
js = is+1;
I = [I;is;js];
J = [J;js;is];
% connect horizontally (right, then left)
is = [1:N-height]';
js = is+height;
I = [I;is;js];
J = [J;js;is];
% connect diagonally (down-right then up-left)
is = [1:N-height-1]'; is([height:height:N-height-1])=[];
js = is+height+1;
I = [I;is;js];
J = [J;js;is];
% connect diagonally (down-left then up-right)
is = [1:N-height]'; is([1:height:N-height])=[];
js = is+height-1;
I = [I;is;js];
J = [J;js;is];


E = [I,J];

