function [ C ] = update_struct( A, B )
% Updates struct A with fields in struct B
%   and returns the updated struct C
%
%   Overlapping fields are updated, new fields are added.
%
% Source (date 2015-04-02):
%   http://stackoverflow.com/questions/15245167/update-struct-via-another-struct-in-matlab
%

%// Remove overlapping fields from first struct
C = rmfield(A, intersect(fieldnames(A), fieldnames(B)));

%// Obtain all unique names of remaining fields
names = [fieldnames(C); fieldnames(B)];

%// Merge both structs
C = cell2struct([struct2cell(C); struct2cell(B)], names, 1);

end

